//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <stdio.h>
#include "Trans1.h"
#include "Trans2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFMain *FMain;
//---------------------------------------------------------------------------
__fastcall TFMain::TFMain(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------

bool TFMain::LoadRC (String fname, int grididx)
{
	// RC
    FILE *frc;
    if ((frc=fopen(fname.c_str(),"rt"))==NULL) return false;
    while (!feof(frc))
    {   char line[255],name[255];
    	if (fgets(line,255,frc)==NULL) break;
        char *pos1,*pos2;
        if ((pos1=strstr(line,"\""))==NULL) continue;
        pos1++;
        if ((pos2=strstr(pos1,"\""))==NULL) continue;
        if (sscanf(line," %s",name)!=1) continue;
        name[strlen(name)-1]=0;
        int found=0;
        for (int n=1; n<SGRes->RowCount; n++)
        {	if (SGRes->Cells[0][n]==String(name))
        	{	found=n; break;
            }
        }
        if (!found) continue;
        *pos2=0;
        SGRes->Cells[grididx][found]=String(pos1);
    }
    fclose(frc);
    return true;
}

bool TFMain::LoadRH (String fname)
{
    FILE *frh;
    if ((frh=fopen(fname.c_str(),"rt"))==NULL) return false;
    int count=1;
    while (!feof(frh))
    {   char line[255],p[3][255];
    	if (fgets(line,255,frh)==NULL) break;
        if (sscanf(line,"%s %s %s",p[0],p[1],p[2])!=3) continue;
        if (strcmp(p[0],"#define")!=0) continue;
        SGRes->Cells[0][count]=p[1];
        count++;
    }
    fclose(frh);
    return true;
}

bool TFMain::SaveRH (String fname)
{
    FILE *frh;
    if ((frh=fopen(fname.c_str(),"wt"))==NULL) return false;
    int count=FSettings->EStartId->Text.ToInt();
    for (int n=1; n<SGRes->RowCount; n++)
    {   String hid=SGRes->Cells[0][n];
    	if (hid=="") continue;
		fprintf(frh,"#define %s \t%d\n",hid.c_str(),count);
        count++;
    }
    fclose(frh);
    return true;
}

bool TFMain::SaveRC (String fname, int grididx)
{
	// RC
    FILE *frc;
    if ((frc=fopen(fname.c_str(),"wt"))==NULL) return false;
    String s="#include \""+FSettings->RHName+"\"\n";
    fprintf(frc,s.c_str());
    fprintf(frc,"STRINGTABLE\n");
    fprintf(frc,"{\n");
	for (int n=1; n<SGRes->RowCount; n++)
    {   String hid=SGRes->Cells[0][n];
    	if (hid=="") continue;
        String line="\t"+hid+",\t\""+SGRes->Cells[grididx][n]+"\"\n";
        fprintf(frc,line.c_str());
    }
    fprintf(frc,"}\n");
    fclose(frc);
    return true;
}

void __fastcall TFMain::SGResDblClick(TObject *Sender)
{
    String s=FSettings->EFunction->Text+"("+SGRes->Cells[0][SGRes->Row]+")";
    EClipboard->Text=s;
    EClipboard->SelectAll();
    EClipboard->CopyToClipboard();
}
//---------------------------------------------------------------------------
void __fastcall TFMain::BSettingsClick(TObject *Sender)
{
	FSettings->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TFMain::BSaveClick(TObject *Sender)
{
	// save RH
    SaveRH(FSettings->RHName);
    // save RCs
    for (int n=1; n<FSettings->SGResFiles->RowCount; n++)
    {   String s=FSettings->SGResFiles->Cells[0][n];
    	String fname=FSettings->EProjDir->Text+"\\"+FSettings->SGResFiles->Cells[1][n]+"\\"+s;
    	SaveRC(fname,n);
    }
}
//---------------------------------------------------------------------------


